import { ElementRef, EventEmitter, OnChanges, OnDestroy, OnInit, SimpleChanges } from '@angular/core';
import { SkyAffixAutoFitContext } from './affix-auto-fit-context';
import { SkyAffixHorizontalAlignment } from './affix-horizontal-alignment';
import { SkyAffixOffset } from './affix-offset';
import { SkyAffixOffsetChange } from './affix-offset-change';
import { SkyAffixPlacement } from './affix-placement';
import { SkyAffixPlacementChange } from './affix-placement-change';
import { SkyAffixPosition } from './affix-position';
import { SkyAffixVerticalAlignment } from './affix-vertical-alignment';
import { SkyAffixService } from './affix.service';
import * as i0 from "@angular/core";
/**
 * Affixes the host element to a base element.
 */
export declare class SkyAffixDirective implements OnInit, OnChanges, OnDestroy {
    #private;
    /**
     * The base element to affix the host element.
     */
    skyAffixTo: HTMLElement | undefined;
    /**
     * Sets the `autoFitContext` property of [[SkyAffixConfig]].
     */
    affixAutoFitContext: SkyAffixAutoFitContext | undefined;
    /**
     * Sets the `autoFitOverflowOffset` property of [[SkyAffixConfig]].
     */
    affixAutoFitOverflowOffset: SkyAffixOffset | undefined;
    /**
     * Sets the `enableAutoFit` property of [[SkyAffixConfig]].
     */
    affixEnableAutoFit: boolean | undefined;
    /**
     * Sets the `horizontalAlignment` property of [[SkyAffixConfig]].
     */
    affixHorizontalAlignment: SkyAffixHorizontalAlignment | undefined;
    /**
     * Sets the `isSticky` property of [[SkyAffixConfig]].
     */
    affixIsSticky: boolean | undefined;
    /**
     * Sets the `placement` property of [[SkyAffixConfig]].
     */
    affixPlacement: SkyAffixPlacement | undefined;
    /**
     * Sets the `position` property of [[SkyAffixConfig]].
     */
    affixPosition: SkyAffixPosition | undefined;
    /**
     * Sets the `verticalAlignment` property of [[SkyAffixConfig]].
     */
    affixVerticalAlignment: SkyAffixVerticalAlignment | undefined;
    /**
     * Fires when the affixed element's offset changes.
     */
    affixOffsetChange: EventEmitter<SkyAffixOffsetChange>;
    /**
     * Fires when the affixed element's overflow container is scrolled.
     */
    affixOverflowScroll: EventEmitter<void>;
    /**
     * Fires when the placement value changes.
     */
    affixPlacementChange: EventEmitter<SkyAffixPlacementChange>;
    constructor(elementRef: ElementRef, affixService: SkyAffixService);
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<SkyAffixDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<SkyAffixDirective, "[skyAffixTo]", never, { "skyAffixTo": { "alias": "skyAffixTo"; "required": false; }; "affixAutoFitContext": { "alias": "affixAutoFitContext"; "required": false; }; "affixAutoFitOverflowOffset": { "alias": "affixAutoFitOverflowOffset"; "required": false; }; "affixEnableAutoFit": { "alias": "affixEnableAutoFit"; "required": false; }; "affixHorizontalAlignment": { "alias": "affixHorizontalAlignment"; "required": false; }; "affixIsSticky": { "alias": "affixIsSticky"; "required": false; }; "affixPlacement": { "alias": "affixPlacement"; "required": false; }; "affixPosition": { "alias": "affixPosition"; "required": false; }; "affixVerticalAlignment": { "alias": "affixVerticalAlignment"; "required": false; }; }, { "affixOffsetChange": "affixOffsetChange"; "affixOverflowScroll": "affixOverflowScroll"; "affixPlacementChange": "affixPlacementChange"; }, never, never, false, never>;
}
