import { ViewportRuler } from '@angular/cdk/overlay';
import { SkyAffixOffset } from './affix-offset';
import { AffixRect } from './affix-rect';
/**
 * Returns the offset values of a given element.
 * @param element The HTML element.
 * @param bufferOffset An optional offset to add/subtract to the element's actual offset.
 */
export declare function getElementOffset(element: HTMLElement, bufferOffset?: SkyAffixOffset): Required<SkyAffixOffset>;
/**
 * Returns an AffixRect that represents the outer dimensions of a given element.
 */
export declare function getOuterRect(element: HTMLElement): Required<AffixRect>;
/**
 * Returns the visible rect for a given element.
 */
export declare function getVisibleRectForElement(viewportRuler: ViewportRuler, element: HTMLElement): Required<AffixRect>;
export declare function getOverflowParents(child: HTMLElement): HTMLElement[];
/**
 * Confirms offset is fully visible within a parent element.
 */
export declare function isOffsetFullyVisibleWithinParent(viewportRuler: ViewportRuler, parent: HTMLElement, offset: Required<SkyAffixOffset>, bufferOffset?: SkyAffixOffset): boolean;
export declare function isOffsetPartiallyVisibleWithinParent(viewportRuler: ViewportRuler, parent: HTMLElement, offset: Required<SkyAffixOffset>, bufferOffset?: SkyAffixOffset): boolean;
