import { SkyMediaBreakpoints } from '../media-query/media-breakpoints';
import { SkyBreakpoint } from './breakpoint';
/**
 * Whether the value is of type `SkyBreakpoint`.
 * @internal
 */
export declare function isSkyBreakpoint(value: SkyBreakpoint | SkyMediaBreakpoints | null | undefined): value is SkyBreakpoint;
/**
 * Transforms a `SkyMediaBreakpoints` value to `SkyBreakpoint`.
 * @internal
 */
export declare function toSkyBreakpoint(breakpoint: SkyMediaBreakpoints): SkyBreakpoint;
/**
 * Transforms a `SkyBreakpoint` value to `SkyMediaBreakpoints`.
 * @internal
 */
export declare function toSkyMediaBreakpoints(breakpoint: SkyBreakpoint): SkyMediaBreakpoints;
