import { Injector } from '@angular/core';
import { Observable } from 'rxjs';
import { SkyBreakpoint } from './breakpoint';
import * as i0 from "@angular/core";
/**
 * Overrides the `SkyMediaQueryService` to emit breakpoint changes when the host
 * container is resized. This directive also adds SKY UX CSS classes to the
 * host element to allow for responsive styles.
 */
export declare class SkyResponsiveHostDirective {
    #private;
    /**
     * Emits when the breakpoint changes.
     */
    get breakpointChange(): Observable<SkyBreakpoint>;
    /**
     * The injector of the responsive host. Useful when displaying child components
     * via `ngTemplateOutlet`.
     * @example```
     * <my-container #responsiveHost="skyResponsiveHost">
     *   <ng-container
     *     [ngTemplateOutlet]="myTemplate"
     *     [ngTemplateOutletInjector]="responsiveHost.injector"
     *   />
     * </my-container>
     * ```
     */
    get injector(): Injector;
    constructor();
    static ɵfac: i0.ɵɵFactoryDeclaration<SkyResponsiveHostDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<SkyResponsiveHostDirective, "[skyResponsiveHost]", ["skyResponsiveHost"], {}, {}, never, never, true, never>;
}
