import { Observable } from 'rxjs';
import { SkyContentInfo } from './content-info';
import * as i0 from "@angular/core";
/**
 * @internal
 * An API to provide information about a parent component's content to child components.
 * For example, toolbar can use this to provide its child components with a list
 * descriptor they can use to construct aria labels, or tree view can provide the node
 * name to its context menus.
 */
export declare class SkyContentInfoProvider {
    #private;
    patchInfo(value: SkyContentInfo): void;
    getInfo(): Observable<SkyContentInfo>;
    static ɵfac: i0.ɵɵFactoryDeclaration<SkyContentInfoProvider, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<SkyContentInfoProvider>;
}
