import { Observable } from 'rxjs';
/**
 * Represents a single item added to the dock.
 */
export declare class SkyDockItem<T> {
    #private;
    readonly componentInstance: T;
    readonly stackOrder: number;
    /**
     * An event that emits when the item is removed from the dock.
     */
    get destroyed(): Observable<void>;
    /**
     * @param componentInstance The item's component instance.
     * @param stackOrder The assigned stack order of the docked item.
     */
    constructor(componentInstance: T, stackOrder: number);
    /**
     * Removes the item from the dock.
     */
    destroy(): void;
}
