import { Type } from '@angular/core';
import { SkyDockInsertComponentConfig } from './dock-insert-component-config';
import { SkyDockItem } from './dock-item';
import { SkyDockOptions } from './dock-options';
import * as i0 from "@angular/core";
/**
 * This service docks components to specific areas on the page.
 */
export declare class SkyDockService {
    #private;
    private static dockRef;
    private static _items;
    /**
     * Returns all docked items.
     */
    get items(): SkyDockItem<any>[];
    /**
     * Docks a component to the bottom of the page.
     * @param component The component to dock.
     * @param config Options that affect the docking action.
     */
    insertComponent<T>(component: Type<T>, config?: SkyDockInsertComponentConfig): SkyDockItem<T>;
    /**
     * Sets options for the positioning and styling of the dock component. Since the dock service is a
     * singleton instance, these options will be applied to all components inserted into the dock. In
     * order to create a separate dock with different options, consumers should provide a different
     * instance of the dock service.
     * @param options The options for positioning and styling
     */
    setDockOptions(options: SkyDockOptions): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<SkyDockService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<SkyDockService>;
}
