/**
 * The location on the page where the dynamic component should be rendered.
 */
export declare enum SkyDynamicComponentLocation {
    /**
     * Renders the dynamic component before a given element.
     */
    BeforeElement = 0,
    /**
     * Renders the dynamic component as the last element inside the BODY element.
     */
    BodyBottom = 1,
    /**
     * Renders the dynamic component as the first element inside the BODY element.
     */
    BodyTop = 2,
    /**
     * Renders the dynamic component as the last element inside a given element.
     */
    ElementBottom = 3,
    /**
     * Renders the dynamic component as the first element inside a given element.
     */
    ElementTop = 4
}
