import { Observable } from 'rxjs';
import { SkyHelpOpenArgs } from './help-open-args';
import { SkyHelpUpdateArgs } from './help-update-args';
import * as i0 from "@angular/core";
/**
 * Provides methods for opening and updating a globally accessible help dialog.
 */
export declare abstract class SkyHelpService {
    /**
     * Emits when the help widget ready state changes.
     */
    get widgetReadyStateChange(): Observable<boolean>;
    /**
     * Opens a globally accessible help dialog.
     * @param args The options for opening the help dialog.
     */
    abstract openHelp(args?: SkyHelpOpenArgs): void;
    /**
     * Updates a globally accessible help dialog.
     * @param args The options for updating the help dialog.
     */
    abstract updateHelp(args: SkyHelpUpdateArgs): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<SkyHelpService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<SkyHelpService>;
}
