import { OnDestroy } from '@angular/core';
import { ReplaySubject } from 'rxjs';
import { SkyLiveAnnouncerArgs } from './types/live-announcer-args';
import * as i0 from "@angular/core";
/**
 * Allows for announcing messages to screen reader users through the use of a common `aria-live` element.
 * @internal
 */
export declare class SkyLiveAnnouncerService implements OnDestroy {
    #private;
    announcerElementChanged: ReplaySubject<HTMLElement | undefined>;
    constructor();
    /**
     * Announces a message to screen readers.
     * @param message Message to be announced to the screen reader.
     * @param args Options for the announcement of the message.
     */
    announce(message: string, args?: SkyLiveAnnouncerArgs): void;
    /**
     * Clears the current text from the announcer element. Can be used to prevent
     * screen readers from reading the text out again while the user is going
     * through the page landmarks.
     */
    clear(): void;
    /**
     * @internal
     */
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<SkyLiveAnnouncerService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<SkyLiveAnnouncerService>;
}
