import { ChangeDetectorRef, OnDestroy, PipeTransform } from '@angular/core';
import { SkyAppLocaleProvider } from '@skyux/i18n';
import { SkyNumericOptions } from './numeric.options';
import { SkyNumericService } from './numeric.service';
import * as i0 from "@angular/core";
/**
 * Shortens numbers to rounded numbers and abbreviation characters such as K for thousands,
 * M for millions, B for billions, and T for trillions. The pipe also formats for currency.
 * Be sure you have a space after the two curly brackets opening the pipe and
 * a space before the two curly brackets closing the pipe or it will not work.
 */
export declare class SkyNumericPipe implements PipeTransform, OnDestroy {
    #private;
    constructor(localeProvider: SkyAppLocaleProvider, numericSvc: SkyNumericService, changeDetector: ChangeDetectorRef);
    ngOnDestroy(): void;
    /**
     * Formats a number based on the provided options.
     */
    transform(value: number | undefined | null, config?: SkyNumericOptions): string;
    static ɵfac: i0.ɵɵFactoryDeclaration<SkyNumericPipe, never>;
    static ɵpipe: i0.ɵɵPipeDeclaration<SkyNumericPipe, "skyNumeric", false>;
}
