import { ComponentRef, ElementRef, EmbeddedViewRef, OnDestroy, OnInit, StaticProvider, TemplateRef, Type, ViewContainerRef } from '@angular/core';
import { Observable, ReplaySubject } from 'rxjs';
import { SkyOverlayPosition } from './overlay-position';
import * as i0 from "@angular/core";
/**
 * @internal
 */
export declare class SkyOverlayComponent implements OnInit, OnDestroy {
    #private;
    wrapperClass: string;
    get backdropClick(): Observable<void>;
    get closed(): Observable<void>;
    enablePointerEvents: boolean;
    id: string;
    showBackdrop: boolean;
    zIndex: string;
    protected clipPath$: ReplaySubject<string | undefined>;
    protected position: SkyOverlayPosition;
    overlayContentRef: ElementRef | undefined;
    overlayRef: ElementRef | undefined;
    targetRef: ViewContainerRef | undefined;
    constructor();
    ngOnInit(): void;
    ngOnDestroy(): void;
    attachComponent<C>(component: Type<C>, providers?: StaticProvider[]): ComponentRef<C>;
    attachTemplate<T>(templateRef: TemplateRef<T>, context: T): EmbeddedViewRef<T>;
    updateClipPath(clipPath: string | undefined): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<SkyOverlayComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<SkyOverlayComponent, "sky-overlay", never, {}, {}, never, never, true, never>;
}
