import { SkyDynamicComponentLegacyService, SkyDynamicComponentService } from '../dynamic-component/dynamic-component.service';
import { SkyOverlayConfig } from './overlay-config';
import { SkyOverlayInstance } from './overlay-instance';
import * as i0 from "@angular/core";
/**
 * This service is used to create new overlays.
 * @internal
 */
export declare class SkyOverlayService {
    #private;
    private static overlays;
    constructor(dynamicComponentSvc: SkyDynamicComponentService);
    /**
     * Creates an empty overlay. Use the returned `SkyOverlayInstance` to append content.
     * @param config Configuration for the overlay.
     */
    create(config?: SkyOverlayConfig): SkyOverlayInstance;
    /**
     * Closes (and destroys) an overlay instance.
     * @param instance The instance to close.
     */
    close(instance: SkyOverlayInstance): void;
    /**
     * Closes all overlay instances.
     */
    closeAll(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<SkyOverlayService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<SkyOverlayService>;
}
/**
 * This service is used to create new overlays.
 * @internal
 * @deprecated Use `SkyOverlayService` to open a standalone component instead.
 */
export declare class SkyOverlayLegacyService extends SkyOverlayService {
    constructor(dynamicComponentSvc: SkyDynamicComponentLegacyService);
    static ɵfac: i0.ɵɵFactoryDeclaration<SkyOverlayLegacyService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<SkyOverlayLegacyService>;
}
