import { EventEmitter, OnDestroy } from '@angular/core';
import { SkyScrollShadowEventArgs } from './scroll-shadow-event-args';
import * as i0 from "@angular/core";
/**
 * Raises an event when the box shadow for a component's header or footer should be adjusted
 * based on the scroll position of the host element.
 * @internal
 */
export declare class SkyScrollShadowDirective implements OnDestroy {
    #private;
    set skyScrollShadowEnabled(value: boolean);
    get skyScrollShadowEnabled(): boolean;
    skyScrollShadow: EventEmitter<SkyScrollShadowEventArgs>;
    windowResize(): void;
    scroll(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<SkyScrollShadowDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<SkyScrollShadowDirective, "[skyScrollShadow]", never, { "skyScrollShadowEnabled": { "alias": "skyScrollShadowEnabled"; "required": false; }; }, { "skyScrollShadow": "skyScrollShadow"; }, never, never, true, never>;
}
