import { ComponentHarness } from '@angular/cdk/testing';
/**
 * Harness used to interact with native input elements in tests.
 */
export declare class SkyInputHarness extends ComponentHarness {
    /**
     * Blurs the input.
     */
    blur(): Promise<void>;
    /**
     * Clears the input value.
     */
    clear(): Promise<void>;
    /**
     * Focuses the input.
     */
    focus(): Promise<void>;
    /**
     * Gets the value of the input.
     */
    getValue(): Promise<string>;
    /**
     * Whether the input is disabled.
     */
    isDisabled(): Promise<boolean>;
    /**
     * Whether the input is focused.
     */
    isFocused(): Promise<boolean>;
    /**
     * Sets the value of the input. The value will be set by simulating key
     * presses that correspond to the given value.
     */
    setValue(value: string): Promise<void>;
}
