import { ComponentHarness, HarnessQuery, TestElement } from '@angular/cdk/testing';
import { SkyComponentHarness } from './component-harness';
/**
 * @internal
 */
export declare abstract class SkyQueryableComponentHarness extends SkyComponentHarness {
    /**
     * Returns a child harness or throws an error if not found.
     */
    queryHarness<T extends ComponentHarness>(query: HarnessQuery<T>): Promise<T>;
    /**
     * Returns a child harness or null if not found.
     */
    queryHarnessOrNull<T extends ComponentHarness>(query: HarnessQuery<T>): Promise<T | null>;
    /**
     * Returns child harnesses.
     */
    queryHarnesses<T extends ComponentHarness>(harness: HarnessQuery<T>): Promise<T[]>;
    /**
     * Returns a child test element or throws an error if not found.
     */
    querySelector(selector: string): Promise<TestElement>;
    /**
     * Returns a child test element or null if not found.
     */
    querySelectorOrNull(selector: string): Promise<TestElement | null>;
    /**
     * Returns child test elements.
     */
    querySelectorAll(selector: string): Promise<TestElement[]>;
}
